#!/bin/sh
#export JAVA_HOME=/data/jdk1.8
#export JRE_HOME=$JAVA_HOME/jre
#export CLASSPATH=.:$JAVA_HOME/lib:$JRE_HOME/lib:$CLASSPATH
#export PATH=$JAVA_HOME/bin:$JRE_HOME/bin:$PATH

basepath=$(cd `dirname $0`; pwd)
dataDir=$basepath"/../data"
conf_file=$basepath"/../conf/dataMigration.properties"
job_conf=$basepath"/JobConf"
appKey="test"
conf_mode=0
start_mode=0

if [[ $# -eq 0 ]]; then
    echo "参数个数不能为0! 请阅读工具使用文档后重新运行脚本！"
    echo "******  易观数据导入程序启动失败  ******"
    exit 1
elif [[ $# -ge 1 ]]; then
    echo "********  启动易观数据导入程序  ********"
    if [[ $1 -eq 0 ]]; then
        if [[ $# -eq 1 ]]; then
            echo "未指定配置参数,将加载默认配置文件,请确认 conf/dataMigration.properties 文件已经配置正确 "
            appKey=$(cat $conf_file | grep base.appKey | cut -d \= -f 2)
            dataDir=$(cat $conf_file | grep base.source.dataDir | cut -d \= -f 2)
            echo "配置文件指定 AppKey 为 :  $appKey , 源数据目录为 : $dataDir"
            read -r -p "确认请输入 y , 输入不正确请输入 n  " input
            case $input in
                [yY])
                    ;;
                [nN])
                    echo "启动参数指定错误,请重新运行脚本!"
                    exit 1
                    ;;    
                *)
                    echo "输入不合法,请检查参数后重新运行脚本！"
                    echo "******  易观数据导入程序启动失败  ******"
                    exit 1
                    ;;
            esac
        elif [[ $# -eq 2 ]]; then
            echo "指定AppKey为 : $2 ,源数据目录为导入工具根目录下的 data 目录"
            read -r -p "确认请输入 y , 输入不正确请输入 n  " input
            case $input in
                [yY])
                    appKey=$2
                    ;;
                [nN])
                    echo "启动参数指定错误,请重新运行脚本!"
                    exit 1
                    ;;    
                *)
                    echo "输入不合法,请检查参数后重新运行脚本！"
                    echo "******  易观数据导入程序启动失败  ******"
                    exit 1
                    ;;
            esac
            conf_mode=1
        elif [[ $# -eq 3 ]]; then
            echo "指定AppKey为 : $2 , 源数据目录为 : $3"
            read -r -p "确认请输入 y , 输入不正确请输入 n  " input
            case $input in
                [yY])
                    appKey=$2
                    dataDir=$3
                    ;;
                [nN])
                    echo "启动参数指定错误,请重新运行脚本!"
                    exit 1
                    ;;    
                *)
                    echo "输入不合法,请检查参数后重新运行脚本!"
                    echo "******  易观数据导入程序启动失败  ******"
                    exit 1
                    ;;
            esac
            conf_mode=2
        else
            echo "指定参数个数不能大于三个,请检查后重新运行启动脚本!"
            echo "******  易观数据导入程序启动失败  ******"
            exit 1
        fi
    elif [[ $1 -eq 1 ]]; then
        if [[ $# -eq 1 ]]; then
            appKey=$(cat $job_conf | grep IMPORT |  cut -d \# -f 2)
            dataDir=$(cat $job_conf | grep IMPORT |  cut -d \# -f 3)
            echo "继续导入数据 - AppKey为 : " $appKey " ,源数据目录为 : " $dataDir
            read -r -p "确认请输入 y , 输入不正确请输入 n  " input
            case $input in
                [yY])
                    ;;
                [nN])
                    echo "启动参数指定错误,请重新运行脚本!"
                    exit 1
                    ;;    
                *)
                    echo "输入不合法,请检查参数后重新运行脚本!"
                    echo "******  易观数据导入程序启动失败  ******"
                    exit 1
                    ;;
            esac
            start_mode=1
            conf_mode=3
        else
            echo "继续导入数据不可指定参数,请阅读工具使用文档后重新运行脚本！"
            echo ""
            echo "******  易观数据导入程序启动失败  ******"
            exit
        fi
    else
        echo "第一个参数只能为 0 (首次启动) 或 1 (继续导入)"
        echo "******  易观数据导入程序启动失败  ******"
        exit 
    fi
fi


start_log_file=$basepath"/../logs/start.log"
echo "`date '+%Y-%m-%d %H:%M:%S'`  -->  JAVA_HOME:"$JAVA_HOME >> $start_log_file

jar_dir=$basepath"/../jars"
jar_file=`ls "$jar_dir" | grep .jar`

jar_file=$jar_dir"/"${jar_file}
echo "`date '+%Y-%m-%d %H:%M:%S'`  -->  jar_file:"$jar_file >> $start_log_file
log_dir=$basepath"/../logs"

if [ ! -d "$log_dir" ]; then
        echo "$log_dir not exist" >> $start_log_file
        mkdir "$log_dir"
fi

conf_file=$basepath"/../conf/dataMigration.properties"
log_dir=$basepath"/../logs"

nohup java  -server  -Xmn256m -Xss512k -XX:+DisableExplicitGC -XX:+UseConcMarkSweepGC  -XX:LargePageSizeInBytes=128m  -XX:+UseFastAccessorMethods -XX:+UseCMSInitiatingOccupancyOnly  -XX:MaxMetaspaceSize=300m  -cp $jar_file com.analysys.migration.bootstrap.Application $conf_file $log_dir $start_mode $conf_mode $appKey $dataDir >> /dev/null 2>&1 &

lryhis_file=$basepath"/lryhis.pid"
echo "`date '+%Y-%m-%d %H:%M:%S'`  -->  lryhis_file:"$lryhis_file >> $start_log_file
echo $! > $lryhis_file 
echo "`date '+%Y-%m-%d %H:%M:%S'`  -->  pid:"$! >> $start_log_file
echo "程序运行PID为 : "$!

# 程序启动标识
shutdown_file=$basepath"/../logs/shutdown.log"
echo "1" > $shutdown_file

echo "******  易观数据导入程序启动成功  ******"